// klasy oraz instrukcje APDU warto zdefiniowa 
final static byte SAMPLE_CLA=(byte)0x80;
final static byte SAMPLE_INS=(byte)0x20;

// metoda przetwarzajca komend APDU
public void process(APDU apdu)
{
    // pobranie zawartoci bufora komendy
    byte[] buffer = apdu.getBuffer();

    // w przypadku uycia kanaw logicznych konieczne jest uycie maski, 
    // ktra spowoduje zignorowanie dwch najmodszych bitw (oznaczajcych 
    // uyty kana logiczny)
    buffer[ISO7816.OFFSET_CLA]=(byte)(buffer[ISO7816.OFFSET_CLA] & (byte)0xFC);

    // sprawdzenie czy klasa komendy jest prawidowa
    if (buffer[ISO7816.OFFSET_CLA]==SAMPLE_CLA) 
    {
	switch (buffer[ISO7816.OFFSET_INS])       
	{
	    // podjcie odpowiednich dziaa (w zalenoci od instrukcji)
	    case SAMPLE_CLA :
		// wysanie w polu danych 0x0102
		Util.setShort(buffer, (short)0, (short)0x0102);
		apdu.setOutgoingAndSend((short)0, (short)2);
		break;
	    // obsuga kolejnych instrukcji
	    case ... :
		// ...
		break;
	    default:
		// wyjtek - instrukcja nieobsugiwana
		ISOException.throwIt(ISO7816.SW_INS_NOT_SUPPORTED);
	}
    } 
    // jest to komenda ISO 7816
    else if (buffer[ISO7816.OFFSET_CLA]==ISO7816.CLA_ISO7816) 
    {
	// instrukcja SELECT FILE
	if (buffer[ISO7816.OFFSET_INS]==ISO7816.INS_SELECT)
	{
	    if (selectingApplet())
	    {
		// bya to komenda dotyczca apletu
	    }
	    else
	    {
		// komenda dotyczya wewntrznych obiektw apletu
	    }
	} 
	// wyjtek - instrukcja nieobsugiwana
	else ISOException.throwIt(ISO7816.SW_INS_NOT_SUPPORTED);
    }
    // wyjtek - klasa instrukcji nieobsugiwana
    else ISOException.throwIt(ISO7816.SW_CLA_NOT_SUPPORTED);
}

