#include <stdlib.h>

// pliki nagwkowe SCEZ
#include <scgeneral.h>
#include <screader.h>

int main(int argc, char *argv[])
{
    // informacje o czytniku
    SC_READER_INFO *ri;
    
    // informacje o karcie
    SC_CARD_INFO *ci;
    
    // konfiguracja czytnika
    SC_READER_CONFIG rc;

    // komenda i odpowied APDU
    SC_APDU *apdu;

    // komenda GET CHALLENGE
    BYTE GET_CHALLENGE[] = {0x00, 0x84, 0x00, 0x00, 0x08};

    // zmienna pomocnicza
    int ret, i;
    
    // inicjalizacja biblioteki
    scInit();

    // konfiguracja czytnika
    rc.type=SC_READER_TOWITOKO;
    rc.slot=1;
    rc.param="0";

    // inicjalizacja struktury ri
    ri=scGeneralNewReader(rc.type, rc.slot);

    // inicjalizacja struktury ci
    ci=scGeneralNewCard();

    // inicjalizacja czytnika 
    scReaderInit(ri, rc.param);

    // aktywacja czytnika
    scReaderActivate(ri);

    // sprawdzenie obecnoci karty w slocie czytnika
    scReaderCardStatus(ri);
    if (!(ri->status&SC_CARD_STATUS_PRESENT))
    {
	printf("No card!\n");
	return 1;
    }

    // zerowanie karty
    scReaderResetCard(ri, ci);

    // wydruk ATR
    printf("ATR [%d] : ", ci->atrlen);
    for (i=0; i<ci->atrlen; i++)
	printf("%02X ", ci->atr[i]);
    
    printf("\n");

    // komenda APDU
    apdu=scGeneralNewAPDU();

    apdu->cmd=GET_CHALLENGE;
    apdu->cmdlen=sizeof(GET_CHALLENGE);
    apdu->cse=SC_APDU_CASE_2_SHORT;

    // przesanie komendy do karty
    ret=scReaderSendAPDU(ri, ci, apdu);
    if (ret!=SC_EXIT_OK)
    {
	printf("Send APDU error!\n");
	return 1;
    }
    
    // wydruk odpowiedzi karty
    printf("RAPDU [%d] : ", apdu->rsplen);
    for (i=0; i<apdu->rsplen; i++)
	printf("%02X ", apdu->rsp[i]);
    printf("\n");

    // dezaktywacja czytnika
    scReaderDeactivate(ri);
    scReaderShutdown(ri);

    // zwolnienie pamici
    scGeneralFreeCard(&ci);
    scGeneralFreeReader(&ri);
    scGeneralFreeAPDU(&apdu);

    // zakoczenie dziaania biblioteki SCEZ
    scEnd();

    return 0;
}

