// przykad interfejsu obiektu
public interface SampleInterface extends Shareable  
{
    // metoda, ktra moe by wywoywana przez inny aplet
    void getName(byte[] buffer);
}

// klasa implementujca interfejs SampleInterface
public class SampleClass extends Applet implements SampleInterface
{
    // ...
    // implementacja wymaganych metod klasy (install itp.)
    // ...

    // metoda pozwala na uzyskanie referencji do klasy w celu wywoania 
    // metod interfejsu
    public Shareable getShareableInterfaceObject(AID clientAID, byte parameter)  
    {
	// jeeli clientAID oraz parameter spenia odpowiednie warunki zwracamy referencj
	// do instancji klasy SampleClass
	if (parameter==(byte)0)
	    return this;
	// w przeciwnym wypadku zwracamy null
	else return null;
    }
    
    // metoda z interfejsu
    public void grantPoints(byte[] buffer)
    {
	// ...
	// implementacja metody
	// ...
    }
}

// klasa wykorzystujca obiekt SampleClass
public class SampleClient extends Applet
{
    // obiekt wspdzielony
    private SampleInterface shared;
    
    public void sampleMethod (...)
    {
	// pobranie AID obiektu, ktrego metody chcemy wywoywa
	AID sampleAID=JCSystem.lookupAID(...)
	
	// pobranie referencji do apletu
	shared=(SampleInterface) 
	    JCSystem.getAppletShareableInterfaceObject(sampleAID, (byte)0);
        
	// sprawdzenie poprawnoci uzyskanej referencji
	if (shared==null)
	{
	    // nie udalo si uzyska dostpu do apletu
	}
	else
	{
	    // wywoanie metody apletu
	    shared.getName(...);
	}
    }
}

