// zaadowanie do odpowiednich struktur danych aplikacji obsugiwanych przez terminal

// wybr wsplnych aplikacji
switch (EMVApplicationSelect(dane terminala))
{
    case OK: 
	// istniej wsplne aplikacje
	break;
    case FALLBACK :
	// transakcj mona kontynuowa, ale nie z uyciem karty EMV
	return FALLBACK;
    default :       
	// bd - brak wsplnych aplikacji
	return ERROR;
}

// rozpoczcie przetwarzania
if (EMVInitiateApplicationProcessing(dane wsplnych aplikacji)!=OK) 
    // przerwanie transakcji
    return ERROR;

// odczytanie danych aplikacji oraz uwierzytelnienie danych
if ((EMVReadApplicationData()!=OK) || 
    (EMVAuthOfflineData()==TERMINATE_TRANSACTION))
    // przerwanie transakcji
    return ERROR;

// przetwarzanie ogranicze
EMVProcessRestrictions();

// weryfikacja uytkownika
if (EMVVerifyCardHolder()==TERMINATE_TRNANSACTION)
    // przetwarzanie transakcji
    return ERROR;

// zarzdzanie ryzykiem po stronie terminala
EMVManageTerminalRisk();

// decyzja po stronie karty i terminala
switch(EMVAnalyzeTerminalAndCardAction())
{
    case ONLINE: 
	// transakcja ma by wykonana w trybie online
	onlineTransaction=TRUE;
	break;
    case APPROVED:
	// transakcja zatwierdzona
	onlineTransaction=FALSE;
	break;
    case DECLINED:
	// transakcja zostaa odrzucona
	onlineTransaction=FALSE;
	break;
    case FALLBACK: 
	// transakcj mona kontynuowa, ale nie z uyciem karty EMV
	return FALLBACK;
    default:
	// przerwanie transakcji
	return ERROR;
}

// transakcja online
if (onlineTransaction)
{
    // przetwarzanie transakcji (online)
    switch(EMVProcessOnlineData())
    {
	case APPROVED:
	    // transakcja zatwierdzona
	    break;
	case DECLINED:
	    // transakcja zostaa odrzucona
	    break;
	case FALLBACK: 
	    // transakcj mona kontynuowa, ale nie z uyciem karty EMV
	    return FALLBACK;
	default: 
	    // przerwanie transakcji
	    return ERROR;
    }
}

// zakoczenie transkacji - wydruk potwierdzenia dla klienta
